// These are defines, because if they are functions, they are really slow for some reason.

#define incrementCounters1() { \
  p0++; \
  if (p0 >= charsetLen) { \
    return; \
  } \
}

#define incrementCounters1Multi() { \
  p0++; \
  if (p0 >= sharedLengths[0]) { \
    return; \
  } \
}

#define incrementCounters2() { \
  p1++; \
  if (p1 >= charsetLen) { \
    p1 = 0; \
    p0++; \
    if (p0 >= charsetLen) { \
      return; \
    } \
  } \
}

#define incrementCounters2Multi() { \
  p1++; \
  if (p1 >= sharedLengths[1]) { \
    p1 = 0; \
    p0++; \
    if (p0 >= sharedLengths[0]) { \
      return; \
    } \
  } \
}



#define incrementCounters3() { \
  p2++; \
  if (p2 >= charsetLen) { \
    p2 = 0; \
    p1++; \
    if (p1 >= charsetLen) { \
      p1 = 0; \
      p0++; \
      if (p0 >= charsetLen) { \
        return; \
      } \
    } \
  } \
}

#define incrementCounters3Multi() { \
  p2++; \
  if (p2 >= sharedLengths[2]) { \
    p2 = 0; \
    p1++; \
    if (p1 >= sharedLengths[1]) { \
      p1 = 0; \
      p0++; \
      if (p0 >= sharedLengths[0]) { \
        return; \
      } \
    } \
  } \
}

#define incrementCounters4() { \
  p3++; \
  if (p3 >= charsetLen) { \
    p3 = 0; \
    p2++; \
    if (p2 >= charsetLen) { \
      p2 = 0; \
      p1++; \
      if (p1 >= charsetLen) { \
        p1 = 0; \
        p0++; \
        if (p0 >= charsetLen) { \
          return; \
        } \
      } \
    } \
  } \
}

#define incrementCounters4Multi() { \
  p3++; \
  if (p3 >= sharedLengths[3]) { \
    p3 = 0; \
    p2++; \
    if (p2 >= sharedLengths[2]) { \
      p2 = 0; \
      p1++; \
      if (p1 >= sharedLengths[1]) { \
        p1 = 0; \
        p0++; \
        if (p0 >= sharedLengths[0]) { \
          return; \
        } \
      } \
    } \
  } \
}

#define incrementCounters5() { \
  p4++; \
  if (p4 >= charsetLen) { \
    p4 = 0; \
    p3++; \
    if (p3 >= charsetLen) { \
      p3 = 0; \
      p2++; \
      if (p2 >= charsetLen) { \
        p2 = 0; \
        p1++; \
        if (p1 >= charsetLen) { \
          p1 = 0; \
          p0++; \
          if (p0 >= charsetLen) { \
            return; \
          } \
        } \
      } \
    } \
  } \
}

#define incrementCounters5Multi() { \
  p4++; \
  if (p4 >= sharedLengths[4]) { \
    p4 = 0; \
    p3++; \
    if (p3 >= sharedLengths[3]) { \
      p3 = 0; \
      p2++; \
      if (p2 >= sharedLengths[2]) { \
        p2 = 0; \
        p1++; \
        if (p1 >= sharedLengths[1]) { \
          p1 = 0; \
          p0++; \
          if (p0 >= sharedLengths[0]) { \
            return; \
          } \
        } \
      } \
    } \
  } \
}


#define incrementCounters6() { \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
            } \
          } \
        } \
      } \
    } \
  } \
}

#define incrementCounters6Multi() { \
  p5++; \
  if (p5 >= sharedLengths[5]) { \
    p5 = 0; \
    p4++; \
    if (p4 >= sharedLengths[4]) { \
      p4 = 0; \
      p3++; \
      if (p3 >= sharedLengths[3]) { \
        p3 = 0; \
        p2++; \
        if (p2 >= sharedLengths[2]) { \
          p2 = 0; \
          p1++; \
          if (p1 >= sharedLengths[1]) { \
            p1 = 0; \
            p0++; \
            if (p0 >= sharedLengths[0]) { \
              return; \
            } \
          } \
        } \
      } \
    } \
  } \
}

#define incrementCounters7() { \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
            } \
          } \
        } \
      } \
    } \
  } \
} \
}

#define incrementCounters7Multi() { \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
              } \
            } \
          } \
        } \
      } \
    } \
  } \
}

#define incrementCounters8() { \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
            } \
          } \
        } \
      } \
    } \
  } \
} \
} \
}

#define incrementCounters8Multi() { \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
              } \
            } \
          } \
        } \
      } \
    } \
  } \
  } \
}

#define incrementCounters9() { \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
            } \
          } \
        } \
      } \
    } \
  } \
} \
} \
} \
}

#define incrementCounters9Multi() { \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
              } \
            } \
          } \
        } \
      } \
    } \
  } \
  } \
} \
}

#define incrementCounters10() { \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}

#define incrementCounters10Multi() { \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}


#define incrementCounters11() { \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}

#define incrementCounters11Multi() { \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}

#define incrementCounters12() { \
  p11++; \
  if (p11 >= charsetLen) { \
  p11 = 0; \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}}

#define incrementCounters12Multi() { \
  p11++; \
  if (p11 >= sharedLengths[11]) { \
  p11 = 0; \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}}

#define incrementCounters13() { \
  p12++; \
  if (p12 >= charsetLen) { \
  p12 = 0; \
  p11++; \
  if (p11 >= charsetLen) { \
  p11 = 0; \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}}}

#define incrementCounters13Multi() { \
  p12++; \
  if (p12 >= sharedLengths[12]) { \
  p12 = 0; \
  p11++; \
  if (p11 >= sharedLengths[11]) { \
  p11 = 0; \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}}}

#define incrementCounters14() { \
  p13++; \
  if (p13 >= charsetLen) { \
  p13 = 0; \
  p12++; \
  if (p12 >= charsetLen) { \
  p12 = 0; \
  p11++; \
  if (p11 >= charsetLen) { \
  p11 = 0; \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}}}}

#define incrementCounters14Multi() { \
  p13++; \
  if (p13 >= sharedLengths[13]) { \
  p13 = 0; \
  p12++; \
  if (p12 >= sharedLengths[12]) { \
  p12 = 0; \
  p11++; \
  if (p11 >= sharedLengths[11]) { \
  p11 = 0; \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}}}}

#define incrementCounters15() { \
  p14++; \
  if (p14 >= charsetLen) { \
  p14 = 0; \
  p13++; \
  if (p13 >= charsetLen) { \
  p13 = 0; \
  p12++; \
  if (p12 >= charsetLen) { \
  p12 = 0; \
  p11++; \
  if (p11 >= charsetLen) { \
  p11 = 0; \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}}}}}

#define incrementCounters15Multi() { \
  p14++; \
  if (p14 >= sharedLengths[14]) { \
  p14 = 0; \
  p13++; \
  if (p13 >= sharedLengths[13]) { \
  p13 = 0; \
  p12++; \
  if (p12 >= sharedLengths[12]) { \
  p12 = 0; \
  p11++; \
  if (p11 >= sharedLengths[11]) { \
  p11 = 0; \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}}}}}

#define incrementCounters16() { \
  p15++; \
  if (p15 >= charsetLen) { \
  p15 = 0; \
  p14++; \
  if (p14 >= charsetLen) { \
  p14 = 0; \
  p13++; \
  if (p13 >= charsetLen) { \
  p13 = 0; \
  p12++; \
  if (p12 >= charsetLen) { \
  p12 = 0; \
  p11++; \
  if (p11 >= charsetLen) { \
  p11 = 0; \
  p10++; \
  if (p10 >= charsetLen) { \
  p10 = 0; \
  p9++; \
  if (p9 >= charsetLen) { \
  p9 = 0; \
  p8++; \
  if (p8 >= charsetLen) { \
  p8 = 0; \
  p7++; \
  if (p7 >= charsetLen) { \
  p7 = 0; \
  p6++; \
  if (p6 >= charsetLen) { \
  p6 = 0; \
  p5++; \
  if (p5 >= charsetLen) { \
    p5 = 0; \
    p4++; \
    if (p4 >= charsetLen) { \
      p4 = 0; \
      p3++; \
      if (p3 >= charsetLen) { \
        p3 = 0; \
        p2++; \
        if (p2 >= charsetLen) { \
          p2 = 0; \
          p1++; \
          if (p1 >= charsetLen) { \
            p1 = 0; \
            p0++; \
            if (p0 >= charsetLen) { \
              return; \
}}}}}}}}}}}}}}}}}

#define incrementCounters16Multi() { \
  p15++; \
  if (p15 >= sharedLengths[15]) { \
  p15 = 0; \
  p14++; \
  if (p14 >= sharedLengths[14]) { \
  p14 = 0; \
  p13++; \
  if (p13 >= sharedLengths[13]) { \
  p13 = 0; \
  p12++; \
  if (p12 >= sharedLengths[12]) { \
  p12 = 0; \
  p11++; \
  if (p11 >= sharedLengths[11]) { \
  p11 = 0; \
  p10++; \
  if (p10 >= sharedLengths[10]) { \
  p10 = 0; \
  p9++; \
  if (p9 >= sharedLengths[9]) { \
  p9 = 0; \
  p8++; \
  if (p8 >= sharedLengths[8]) { \
  p8 = 0; \
  p7++; \
  if (p7 >= sharedLengths[7]) { \
  p7 = 0; \
  p6++; \
  if (p6 >= sharedLengths[6]) { \
    p6 = 0; \
    p5++; \
    if (p5 >= sharedLengths[5]) { \
      p5 = 0; \
      p4++; \
      if (p4 >= sharedLengths[4]) { \
        p4 = 0; \
        p3++; \
        if (p3 >= sharedLengths[3]) { \
          p3 = 0; \
          p2++; \
          if (p2 >= sharedLengths[2]) { \
            p2 = 0; \
            p1++; \
            if (p1 >= sharedLengths[1]) { \
              p1 = 0; \
              p0++; \
              if (p0 >= sharedLengths[0]) { \
                return; \
}}}}}}}}}}}}}}}}}
